#!/usr/bin/env python3.9
# -*- coding: utf-8 -*- 

# Copyright (c) 2021 Marco Ferrara

# License:
# GNU GPL License
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Dependencies: 
# TODO...

import bpy
from prj.utils import debug_here

svgs_data: list['Svg_data'] = []

def reset_svgs_data():
    global svgs_data
    svgs_data = []

class Svg_data:
    ## TODO Find a better name for the class
    path: str
    subject: 'Drawing_subject'
    data = dict

    def __init__(self, path: str, subject: 'Drawing_subject'):
        if path  in svgs_data:
            return
        self.path = path
        self.subject = subject
        self.data = {}
        svgs_data.append(self)

    def add_data(self, key: str, content) -> None:
        """ Add keyed data to Svg_data """
        self.data[key] = content

    def remove(self) -> None:
        global svgs_data
        if self in svgs_data:
            svgs_data.remove(self)
        del self

